// SheppLogan.c     64x64ff[^p Shepp & Logan tB^̍쐬

#include "HU.h" 

void FFT1D( double x[] , double y[] , int data_n , int invert )
{
	// Numerical Recipes in C (p390-391) p (ꕔύX)B
	
	// invert  1 Ȃ΁A摜 x Pt[Gϊ
	// ʂ  x ,  y ̔zɓB
	// data_n ́Af[^iQ̊K̕KvjB

	// invert  -1 Ȃ΁A x ,  y 
	// Ptt[GϊāAʂ x ̔zɓB
	
	int		i,j,m,n,mmax,istep;
	double	tempi,tempr,temp;
	double	theta,wi,wpi,wpr,wr,wtemp, PI = 3.141592653589793; 
	double	*data;

	data = calloc( (data_n + 1) * 2, sizeof(double) );

	for (i=1; i<=data_n  ; i++ ){
	
		data[2*i-1]=x[i];   data[2*i]=y[i];
	}

		n = data_n << 1;
		j = 1;

		for(i = 1; i < n ; i+=2 ){
		
			if(j > i){
			
				temp=data[j];   data[j]  =data[i];   data[i]  =temp;                
				temp=data[j+1]; data[j+1]=data[i+1]; data[i+1]=temp;
			}
			m = n >> 1;
		
			while( m >= 2 && j > m ){
			
				j -= m;
				m >>= 1;
			}
			
			j += m;
		}
	
		// Danielson-Lanczos  FFT ASY
		
		mmax = 2;
		
		while( n > mmax ){
		
			istep = mmax << 1;
			theta = invert * 2.0 * PI / mmax ; 
			wtemp = sin(0.5*theta);
			wpr = -2.0 * wtemp * wtemp;
			wpi = sin(theta);
			wr = 1.0; wi = 0.0;

			for( m = 1; m < mmax; m+=2 ){

				for( i = m; i <= n; i+=istep ){
					
					j = i + mmax;
					tempr = wr*data[j] - wi*data[j+1];
					tempi = wr*data[j+1] + wi*data[j];
					data[j]   = data[i]-tempr;
					data[j+1] = data[i+1]-tempi;
					data[i]  += tempr;
					data[i+1]+= tempi;
				}
								
				wr = (wtemp=wr)*wpr - wi*wpi + wr;
				wi = wi*wpr + wtemp*wpi + wi;
			}
			
			mmax = istep;
		}

	for (i = 1; i <= data_n  ; i++ ){ 
	
		if(invert ==  1){ x[i] = data[2*i-1];  y[i] = data[2*i]; }
		if(invert == -1){ x[i] = data[2*i-1]/(data_n);  y[i] = data[2*i]/(data_n); }
	}
	
	free(data);
}

void Graph( double x[], int x1, int y1, int x2, int y2, double max, COLORREF color, char *s )
{
	int	i, ip, jp, ip2, jp2 ;
	
	PenWidth(3);  

	SetColor(WHITE); Line(x1, y1, x2, y1); Line(x1, y1, x1, y2);

	SetColor(color); FontSize(20); DrawString(x1+10, y2, s );
	
	for(i=1; i<=255; i++){
	
		ip = x1 + i ;  ip2 = x1 + (i+1) ;

		jp  = y1 - (int)(x[i]*100./max);  jp2 = y1 - (int)(x[i+1]*100./max);  

		Line( ip, jp, ip2, jp2 );
	}	
}

void Main(void)
{
	char	yn, f[100];
	int		i, j, ip, jp, ip2, jp2;  
	double	SL[500], x[257], y[257], RR[257], max, sum, CutOff ,f0, I, PAI=3.1415926;

	FILE *fp;
	
	TextWindow(10,10,350,500); Title("64 Shepp & Logan Filter ");
	GraphicWindow(840,820,BK_BLACK);	
	
 START: printf("\n SheppLogan filter Generator \n"); ClearWindow();
	
//------------------ Generate frequency space SheppLogan filter ----------------

	printf("\n\n Cut off freq. (0`0.5) = ");scanf("%lf",&CutOff );
	
	f0 = 64.0 * CutOff ;   
	
	for ( i=-50; i<=50; i++){  I = (double)i;

		SL[i+50]= abs((f0/PAI)*sin(2.*PAI*I/f0))*pow(sin(PAI*I/f0)/(PAI*I/f0),2.0);
	}
		
//------------------ Display frequency space Ramp filter ----------------
	
	PenWidth(4);  SetColor(WHITE);
	
	Line(10, 200, 410, 200);  Line(210, 200, 210, 10);

	SetColor(YELLOW);  FontSize(20); DrawString(230, 10, "Shepp&Logan filter" );
	
	for(i=-50; i<=50; i++){
	
		ip = 210 + i ;  ip2 = 210 + (i+1) ;
		
		jp  = 200 - (int)(SL[i+50]  )*6;
		jp2 = 200 - (int)(SL[i+1+50])*6; 

		Line(ip,jp, ip2,jp2);
	}	
	PenWidth(1);

//------------------- Transform Ramp filter -------------

	for(i=1; i<=32;i++){ x[i]    = SL[50+i] ; }
	for(i=1; i<=32;i++){ x[i+32] = SL[83-i] ; }

	Graph( x, 500, 200, 780, 20, 20.0, SKYBLUE, "Frequency space Shepp&Logan " );

//------------------- Transform Ramp filter into Real space -------------
	printf("\n\nTransform SheppLogan filter into Real space ");scanf("%c",&yn);

	for(i=1;i<=64; i++){ y[i] = 0.0; }

	FFT1D(x,y,64,-1);
	
//----------------- Get max value of Real space Ramp filter -------------
    
	for(max=0.0, i=1; i<=64; i++ ){ if(x[i] > max ) max = x[i]; }

	printf("\n\n Real SheppLogan max = %.4lf ",max);


	for(i=1; i<=32; i++){ RR[ i ] = x[i+32]; }

	for(i=1; i<=32; i++){ RR[ i+32 ] = x[i]; }
 
//------------------ Integration of Real space Ramp filter ----------------
	
	for( sum=0.0 , i=1; i<=64; i++ ){ sum += RR[i]; }
	
	printf("\n\n Integration of Real space SheppLogan \n\n = %.4lf ",sum);

//------------------ Display Real space Ramp filter ---------------------
	
	PenWidth(4);  SetColor(WHITE);
	
	Line(1, 450, 810, 450); 

	SetColor(RED);   FontSize(20); DrawString(510, 300, "Real space Shepp&Logan " );
	
	for(i=1; i<64; i++){
	
		ip = 10 + i*5 ;  ip2 = 10 + (i+1)*5 ;
		
		jp  = 450 - (int)( 200.0/max * RR[i]  );
		jp2 = 450 - (int)( 200.0/max * RR[i+1]); 

		Line(ip,jp, ip2,jp2);
	}	
//------------------- Transform Ramp filter into x[] ---------

	for(i=1; i<=32; i++){ x[ i ]    = RR[ i+32 ]; }

	for(i=1; i<=32; i++){ x[ i+32 ] = RR[ i ];     }

//------------------ Save Real space Ramp filter --------------------------
		
    printf("\n\n Save Real space SheppLogan filter "); scanf("%c",&yn);
	
	GetFileName( f, 1); 	fp = fopen( f, "wt");

	for(i=1; i<=32; i++){ fprintf( fp, "%.16lf \n",x[i]); }

    fclose(fp);

//---------------- Transform Ramp filter into frequency space ---------

    printf("\n\n Transform SheppLogan filter into frequency space "); scanf("%c",&yn);

	for(i=1; i<=64; i++){ y[ i ]     = 0.0 ;      }
		
	FFT1D(x,y,64,1);
	
	Graph( x, 500, 700, 780, 520, 30.0, GREEN, "FFT of real space Shepp&Logan " );

//------------------- End -------------------------------
	
	printf("\n\n Retry? (no:n) ");scanf("%c",&yn); 	if(yn!='n')goto START;

	exit(0);
}
